## lomiri-download-manager 0.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(lomiri-download-manager VERSION 0.1.3 LANGUAGES CXX)

option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.DownloadManager QML compatibility layer" OFF)
option(ENABLE_DOC "Build documentation" ON)
option(ENABLE_WERROR "Treat all build warnings as errors" ON)
option(USE_SYSTEMD "Install systemd service" ON)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fPIC -pthread")

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "lomiri-download-manager")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

# Standard install paths
include(GNUInstallDirs)

find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${DIALER_APP})
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt5/qml")

set(LDM_VERSION_MAJOR 0)
set(LDM_VERSION_MINOR 1)
set(LDM_VERSION_PATCH 2)

file(GLOB_RECURSE I18N_CPP_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     src/**.cpp)
list(SORT I18N_CPP_SRC_FILES)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Core DBus Network Sql Test REQUIRED)
find_package(Boost COMPONENTS log program_options REQUIRED)

find_package(PkgConfig REQUIRED)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(GLOG REQUIRED libglog)
pkg_check_modules(LOMIRI_API REQUIRED liblomiri-api)

if(USE_SYSTEMD)
  pkg_check_modules(SYSTEMD systemd)
  if (NOT SYSTEMD_FOUND)
    message(FATAL_ERROR "systemd pkg-config not found (required for figuring out service install location)")
  endif()

  pkg_get_variable(SYSTEMD_USER_DIR systemd systemduserunitdir)
endif()

include(CTest)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=c++17 -O2 -Wall -W -D_REENTRANT -fPIC -pedantic -Wextra")
add_definitions("-DNDEBUG")

if(ENABLE_WERROR)
  add_compile_options("-Werror")
endif()

if(NOT CMAKE_BUILD_TYPE)
	message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
	set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://pub    lic.kitware.com/Bug/view.php?id=14696
	add_definitions(-DQT_NO_DEBUG)
endif()

add_subdirectory(src)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()
if(ENABLE_DOC)
  add_subdirectory(docs)
endif(ENABLE_DOC)
add_subdirectory(po)

=== docs/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_custom_target(doc ALL)

find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(cppdoc ALL 
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DOCDIR}/cpp)
  add_dependencies(doc cppdoc)
endif(DOXYGEN_FOUND)

add_subdirectory(qml)
add_subdirectory(man)

=== tests/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

find_package(GMock REQUIRED)
include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(tests-data ALL
        COMMAND cp -r ${CMAKE_SOURCE_DIR}/tests/data ${CMAKE_CURRENT_BINARY_DIR}/data
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

add_subdirectory(common)
add_subdirectory(downloads)
add_subdirectory(uploads)
add_subdirectory(abi-compliance)

=== docs/man/CMakeLists.txt ===
install(
  FILES
    lomiri-download-manager.1
    lomiri-upload-manager.1
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/
)

=== docs/qml/CMakeLists.txt ===
# add a target to generate API documentation with qdoc 5.x
SET(QDOC_WORKS FALSE)
SET(ENV{QT_SELECT} qt5)
FIND_PROGRAM(QDOC_EXECUTABLE qdoc)
if(QDOC_EXECUTABLE)
EXECUTE_PROCESS(COMMAND ${QDOC_EXECUTABLE} --version OUTPUT_VARIABLE QDOC_OUTPUT ERROR_QUIET)
string(REGEX REPLACE "qdoc ([0-9]+(\\.[0-9]+)+).*" "\\1" QDOC_VERSION ${QDOC_OUTPUT})
if(QDOC_VERSION MATCHES "^5\\.")
set(QDOC_WORKS TRUE)
endif()
endif(QDOC_EXECUTABLE)
if(QDOC_WORKS)
message(STATUS "Check for working qdoc: ${QDOC_EXECUTABLE} (version: \"${QDOC_VERSION}\") -- works")
elseif(QDOC_EXECUTABLE)
message(FATAL_ERROR "Check for working qdoc: ${QDOC_EXECUTABLE} -- does not work")
else()
message(FATAL_ERROR "Check for working qdoc: not found")
endif(QDOC_WORKS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lomiri-download-manager.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-download-manager.qdocconf @ONLY)
add_custom_target(qmldoc
${QDOC_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/lomiri-download-manager.qdocconf
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating QML API documentation with qdoc" VERBATIM
)

# copy stylesheet files into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/css"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/html
)

add_dependencies(doc qmldoc)

=== src/downloads/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

add_subdirectory(client)
add_subdirectory(common)
add_subdirectory(daemon)
add_subdirectory(priv)
add_subdirectory(qml)
add_subdirectory(test-daemon)

if(ENABLE_UBUNTU_COMPAT)
    add_subdirectory(qml-compat)
endif()

=== tests/common/CMakeLists.txt ===
set(TARGET lomiri-download-manager-test-lib)

set(SOURCES
        base_testcase.cpp
        daemon_testcase.cpp
        local_tree_testcase.cpp
        testing_interface.cpp
)

set(HEADERS
        apparmor.h
        base_testcase.h
        daemon_testcase.h
        dbus_connection.h
        file_manager.h
        local_tree_testcase.h
        matchers.h
        network_reply.h
        process.h
        process_factory.h
        request_factory.h
        testing_interface.h
        uuid_factory.h
)

include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

add_library(${TARGET} STATIC
    ${HEADERS}
    ${SOURCES}
)

target_link_libraries(${TARGET}
    Qt5::Core
    Qt5::Sql
    Qt5::DBus
    Qt5::Test
    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES}
    ldm-common
    ldm-priv-common
    lomiri-download-manager-common
    lomiri-download-manager-client
)

=== src/common/public/CMakeLists.txt ===
set(TARGET ldm-common)

set(SOURCES
	lomiri/transfers/metadata.cpp
	lomiri/transfers/errors/auth_error_struct.cpp
	lomiri/transfers/errors/hash_error_struct.cpp
	lomiri/transfers/errors/http_error_struct.cpp
	lomiri/transfers/errors/network_error_struct.cpp
	lomiri/transfers/errors/process_error_struct.cpp
	lomiri/transfers/system/dbus_connection.cpp
	lomiri/transfers/system/hash_algorithm.cpp
	lomiri/transfers/system/logger.cpp
)

set(TRANSFERS_PUBLIC_HEADERS
	lomiri/transfers/metadata.h
	lomiri/transfers/visibility.h
)

set(ERRORS_PUBLIC_HEADERS
	lomiri/transfers/errors/auth_error_struct.h
	lomiri/transfers/errors/hash_error_struct.h
	lomiri/transfers/errors/http_error_struct.h
	lomiri/transfers/errors/network_error_struct.h
	lomiri/transfers/errors/process_error_struct.h
)

set(PRIVATE_HEADERS
	lomiri/transfers/system/dbus_connection.h
	lomiri/transfers/system/hash_algorithm.h
	lomiri/transfers/system/logger.h
)

add_library(${TARGET} SHARED
	${SOURCES}
	${TRANSFERS_PUBLIC_HEADERS}
	${ERRORS_PUBLIC_HEADERS}
	${PRIVATE_HEADERS}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/common/public/symbols.map")
set_target_properties(
	${TARGET}

	PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	Qt5::DBus
	Qt5::Network
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${TRANSFERS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers)
install(FILES ${ERRORS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers/errors)

=== src/downloads/client/CMakeLists.txt ===
add_definitions(-DBOOST_LOG_DYN_LINK)

set(TARGET lomiri-download-manager-client)

set(SOURCES
        lomiri/download_manager/download_impl.cpp
        lomiri/download_manager/download_interface.cpp
        lomiri/download_manager/downloads_list_impl.cpp
        lomiri/download_manager/download_pendingcall_watcher.cpp
        lomiri/download_manager/error.cpp
        lomiri/download_manager/group_download.cpp
        lomiri/download_manager/logging/logger.cpp
        lomiri/download_manager/manager.cpp
        lomiri/download_manager/manager_impl.cpp
        lomiri/download_manager/manager_interface.cpp
        lomiri/download_manager/manager_pendingcall_watcher.cpp
        lomiri/download_manager/pending_call_watcher.cpp
        lomiri/download_manager/properties_interface.cpp
)

set(PUBLIC_HEADERS
        lomiri/download_manager/download.h
        lomiri/download_manager/downloads_list.h
        lomiri/download_manager/error.h
        lomiri/download_manager/group_download.h
        lomiri/download_manager/manager.h
        lomiri/download_manager/logging/logger.h
)

set(PRIVATE_HEADERS
        lomiri/download_manager/download_impl.h
        lomiri/download_manager/download_interface.h
        lomiri/download_manager/downloads_list_impl.h
        lomiri/download_manager/download_pendingcall_watcher.h
        lomiri/download_manager/manager_impl.h
        lomiri/download_manager/manager_interface.h
        lomiri/download_manager/manager_pendingcall_watcher.h
        lomiri/download_manager/pending_call_watcher.h
        lomiri/download_manager/properties_interface.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${Boost_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)

add_library(${TARGET} SHARED 
        ${SOURCES}
        ${PUBLIC_HEADERS}
        ${PRIVATE_HEADERS}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/downloads/client/symbols.map")
set_target_properties(
        ${TARGET}

        PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
        VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
        SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
        ${Boost_LIBRARIES}
        Qt5::DBus
        ldm-common
        lomiri-download-manager-common
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/download_manager)

=== src/downloads/common/CMakeLists.txt ===
set(TARGET lomiri-download-manager-common)

set(SOURCES
	lomiri/download_manager/download_state_struct.cpp
	lomiri/download_manager/download_struct.cpp
	lomiri/download_manager/group_download_struct.cpp
	lomiri/download_manager/system/logger.cpp
)

set(PUBLIC_HEADERS
	lomiri/download_manager/download_state_struct.h
	lomiri/download_manager/download_struct.h
	lomiri/download_manager/group_download_struct.h
	lomiri/download_manager/metatypes.h
)

set(PRIVATE_HEADERS
	lomiri/download_manager/system/logger.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)

add_library(${TARGET} SHARED 
	${SOURCES}
	${PUBLIC_HEADERS}
	${PRIVATE_HEADERS}
)


set(symbol_map "${CMAKE_SOURCE_DIR}/src/downloads/common/symbols.map")
set_target_properties(
	${TARGET}

	PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	Qt5::DBus
	ldm-common
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/download_manager)

=== src/downloads/daemon/CMakeLists.txt ===
set(TARGET lomiri-download-manager)

set(SOURCES
	main.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

add_executable(${TARGET}
	${SOURCES}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	Qt5::Core
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
	lomiri-download-manager-priv
)

configure_file(
  ${TARGET}.service.in ${TARGET}.service @ONLY
)
configure_file(
  com.lomiri.applications.Downloader.service.in com.lomiri.applications.Downloader.service @ONLY
)

if(USE_SYSTEMD)
  configure_file(
    lomiri-download-manager-systemd.service.in lomiri-download-manager-systemd.service @ONLY
  )

  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-download-manager-systemd.service
    DESTINATION ${SYSTEMD_USER_DIR}
  )
endif()

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.service DESTINATION
   	${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.applications.Downloader.service DESTINATION
   	${CMAKE_INSTALL_DATADIR}/dbus-1/system-services)
install(FILES com.lomiri.applications.Downloader.conf DESTINATION
   	${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/downloads/priv/CMakeLists.txt ===
set(TARGET lomiri-download-manager-priv)

set(SOURCES
	lomiri/downloads/daemon.cpp
	lomiri/downloads/download.cpp
	lomiri/downloads/download_adaptor.cpp
	lomiri/downloads/download_adaptor_factory.cpp
	lomiri/downloads/download_manager_adaptor.cpp
	lomiri/downloads/download_manager_factory.cpp
	lomiri/downloads/downloads_db.cpp
	lomiri/downloads/factory.cpp
	lomiri/downloads/file_download.cpp
	lomiri/downloads/group_download.cpp
	lomiri/downloads/group_download_adaptor.cpp
	lomiri/downloads/header_parser.cpp
	lomiri/downloads/manager.cpp
	lomiri/downloads/mms_file_download.cpp
	lomiri/downloads/sm_file_download.cpp
	lomiri/downloads/state_machines/download_sm.cpp
	lomiri/downloads/state_machines/final_state.cpp
	lomiri/downloads/state_machines/state.cpp
)

set(HEADERS
	lomiri/downloads/daemon.h
	lomiri/downloads/download.h
	lomiri/downloads/download_adaptor.h
	lomiri/downloads/download_adaptor_factory.h
	lomiri/downloads/download_manager_adaptor.h
	lomiri/downloads/download_manager_factory.h
	lomiri/downloads/downloads_db.h
	lomiri/downloads/factory.h
	lomiri/downloads/file_download.h
	lomiri/downloads/group_download.h
	lomiri/downloads/group_download_adaptor.h
	lomiri/downloads/header_parser.h
	lomiri/downloads/manager.h
	lomiri/downloads/mms_file_download.h
	lomiri/downloads/sm_file_download.h
	lomiri/downloads/state_machines/download_sm.h
	lomiri/downloads/state_machines/final_state.h
	lomiri/downloads/state_machines/state.h
)

include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)

add_definitions(-DHELPER_DIR="${CMAKE_INSTALL_LIBEXECDIR}/lomiri-download-manager")

add_library(${TARGET} STATIC
	${HEADERS}
	${SOURCES}
)

set_target_properties(
	${TARGET}

	PROPERTIES
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
	Qt5::DBus
	Qt5::Sql
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
)

=== debian/changelog ===
lomiri-download-manager (0.1.3-5) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Add to B-D: systemd-dev. (Closes: #1072761).
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 07 Jun 2024 18:46:54 +0200

lomiri-download-manager (0.1.3-4) unstable; urgency=medium

  * Upload to unstable.

  * debian/rules:
    + Stop using pkgkde_symbolshelper tool.
  * debian/control:
    + Drop from B-D: pkg-kde-tools.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 04 Mar 2024 09:16:33 +0100

lomiri-download-manager (0.1.3-3) experimental; urgency=medium

  [ Graham Inggs ]
  * Rename libraries for 64-bit time_t transition.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 22:33:16 +0100

lomiri-download-manager (0.1.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062669

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Feb 2024 09:45:09 +0000

lomiri-download-manager (0.1.3-2) unstable; urgency=medium

  * debian/*.symbols:
    + Remove remaining .symbols files. Follow-up to previous upload.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 22:28:29 +0100

lomiri-download-manager (0.1.3-1) unstable; urgency=medium

  * New upstream release.
    - Drop usage of GetConnectionAppArmorSecurityContext. (Closes: #1057467).
  * debian/copyright:
    + Update copyright attribution for debian/.
    + Update copyright attributions.
    + Update auto-generated copyright.in file.
  * debian/patches:
    + Drop all patches. Applied upstream.
  * debian/*.symbols:
    + Drop .symbols files. Avoid having to maintain them long-term.
  * debian/{*.manpages,*.1}:
    + Use upstream's man pages (which don't get compressed by them, so...).
  * debian/rules
    +  Remove results.txt during dh_clean. (Closes: #1046220).
  * debian/rules:
    + Set ENABLE_WERROR=OFF.
  * debian/patches:
    + Add 0001_use-CMAKE_FULL_INSTALL-variables.patch. Use CMAKE_FULL_INSTALL_*
      variables everywhere.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 18:08:06 +0100

lomiri-download-manager (0.1.2-2) unstable; urgency=medium

  * [debian/*.symbols] Mark unused symbols that would otherwise be optimized out
  * debian/patches: Add patch to fix FTBFS with googletest 1.13.0 (closes #1041088)
  * debian/control: Use my new debian email

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 02:13:05 +0200

=== debian/control ===
Source: lomiri-download-manager
Section: net
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               cmake-extras (>= 1.5-7~),
               debhelper-compat (= 13),
               dh-apparmor,
               doxygen,
               dbus-test-runner,
               googletest,
               graphviz,
               qtbase5-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libdbus-1-dev,
               libqt5sql5-sqlite,
               liblomiri-api-dev (>= 0.1.1),
               libgoogle-glog-dev,
               libgtest-dev (>= 1.10.0.20201025-1~),
               pkg-config,
               python3,
               qml-module-qttest,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               network-manager,
               rdfind,
               symlinks,
               systemd-dev,
               xvfb,
               xauth,
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-download-manager/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-download-manager.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-download-manager/

Package: libldm-common0t64
Provides: ${t64:Provides}
Replaces: libldm-common0
Breaks: libldm-common0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Upload/Download Manager - shared library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library, shared between the
 client lib and the service lib.

Package: libldm-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libldm-common0t64 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Lomiri Upload/Download Manager - development files
 Lomiri Uploadi/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers, shared between the client
 library and the daemon library.

Package: libldm-priv-common0t64
Provides: ${t64:Provides}
Replaces: libldm-priv-common0
Breaks: libldm-priv-common0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0t64 (= ${binary:Version}),
Description: Lomiri Upload/Download Manager - shared private library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes an auxiliary shared (but private) library.

Package: liblomiri-download-manager-common0t64
Provides: ${t64:Provides}
Replaces: liblomiri-download-manager-common0
Breaks: liblomiri-download-manager-common0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: libldm-common0t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Download Manager - common shared library
 Lomiri Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-download-manager-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common0t64 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Download Manager - common development files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: liblomiri-download-manager-client0t64
Provides: ${t64:Provides}
Replaces: liblomiri-download-manager-client0
Breaks: liblomiri-download-manager-client0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0t64 (= ${binary:Version}),
         liblomiri-download-manager-common0t64 (= ${binary:Version}),
Description: QT library for Lomiri Download Manager - shared client library
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package includes the public shared library providing the API
 for implementing a service client.

Package: liblomiri-download-manager-client-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common-dev (= ${binary:Version}),
         liblomiri-download-manager-client0t64 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: lomiri-download-manager-client-dev
Replaces: lomiri-download-manager-client-dev
Description: QT library for Lomiri Download Manager - client development files
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package contains the header that can be used to allow an
 application use the Lomiri Download Manager client library.

Package: liblomiri-download-manager-client-doc
Section: doc
Architecture: all
Depends: liblomiri-download-manager-client-dev (>= ${source:Version}),
          ${misc:Depends},
Description: QT library for Lomiri Download Manager - client documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 Documentation files for the LDM client development.

Package: liblomiri-upload-manager-common0t64
Provides: ${t64:Provides}
Replaces: liblomiri-upload-manager-common0
Breaks: liblomiri-upload-manager-common0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: libldm-common0t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Upload Manager - shared common library
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-upload-manager-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-upload-manager-common0t64 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Upload Manager - common development files
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: lomiri-download-manager
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0t64 (= ${binary:Version}),
         libldm-priv-common0t64 (= ${binary:Version}),
         liblomiri-download-manager-common0t64 (= ${binary:Version}),
         unzip
Suggests: apparmor
Description: Lomiri Download Manager - daemon
 Lomiri Download Manager performs downloads from a centralized
 location.
 .
 This package includes the Lomiri Download Manager user space daemon.

Package: lomiri-upload-manager
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0t64 (= ${binary:Version}),
         libldm-priv-common0t64 (= ${binary:Version}),
         liblomiri-upload-manager-common0t64 (= ${binary:Version}),
Description: Lomiri Upload Manager - daemon
 Lomiri Upload Manager performs uploads from a centralized
 location.
 .
 This package includes the Lomiri Upload Manager user space daemon.

Package: qml-module-lomiri-downloadmanager
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0t64 (= ${binary:Version}),
         liblomiri-download-manager-common0t64 (= ${binary:Version}),
         liblomiri-download-manager-client0t64 (= ${binary:Version}),
         lomiri-download-manager (= ${binary:Version})
Description: Lomiri Download Manager QML Plugin
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains a QML Plugin to handle downloads from a pure QML
 application, without the need to write any C++ code.

Package: qml-module-lomiri-downloadmanager-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Lomiri Download Manager QML Plugin - documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the documentation of the Lomiri DownloadManager
 QML Plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

NULL =

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/architecture.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5

BUILDHOME=$(CURDIR)/debian/build

%:
	dh  $@

override_dh_clean:
	dh_clean
	rm -rfv $(BUILDHOME)
	rm -fv results.txt

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	                     -DENABLE_WERROR=OFF \
	                     $(NULL)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) dh_auto_test

override_dh_auto_install:
	dh_auto_install
	rm -v debian/tmp/usr/lib/*/libldm-priv-common.so
	rm -v debian/tmp/usr/share/man/man1/*.1

override_dh_install:
	# FIXME: remove locale files for now, the requires an upload to NEW and needs coordination with the RT during freeze
	rm -Rv "$(CURDIR)/debian/tmp/usr/share/locale"
	# liblomiri-download-manager-client-doc
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	mv $(CURDIR)/debian/tmp/usr/share/doc/lomiri-download-manager/cpp/* $(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/
	find "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/" -name *.md5 -delete
	rdfind -makesymlinks true "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	symlinks -rc "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	# qml-module-lomiri-downloadmanager
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	mv $(CURDIR)/debian/tmp/usr/share/doc/lomiri-download-manager/qml/* $(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/
	find "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/" -name *.md5 -delete
	rdfind -makesymlinks true "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	symlinks -rc "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	# this directory is empty...
	rmdir debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/html/images/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.lomiri-download-manager.ldm-extractor -plomiri-download-manager
	dh_installdeb

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
